unit u27;   {autor: 27 - mladez}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    tlacitkootevrit: TButton;
    OpenDialog1: TOpenDialog;
    seznam: TListView;
    radka: TStringGrid;
    tlacitkoprepsat: TButton;
    tlacitkonove: TButton;
    tlacitkoulozit: TButton;
    SaveDialog1: TSaveDialog;
    tlacitkosmazat: TButton;
    vhodnytlacitko: TButton;
    procedure FormCreate(Sender: TObject);
    procedure tlacitkootevritClick(Sender: TObject);
    procedure Prekreslit;
    function KontrolaUdaju:boolean;
    procedure tlacitkonoveClick(Sender: TObject);
    procedure seznamClick(Sender: TObject);
    procedure tlacitkoprepsatClick(Sender: TObject);
    procedure tlacitkoulozitClick(Sender: TObject);
    procedure tlacitkosmazatClick(Sender: TObject);
    procedure vhodnytlacitkoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
 tosoba=class  {definice jedne konkretni osoby}
  id:string[10];
  jmeno:string[32];
  prijmeni:string[32];
  muz:boolean;  {true=muz   false=zena}
  narozeni:string[4];
  umrti:string[4];
  matka:string[10];
  otec:string[10];
  partneri:array of string[10];  {vsichni partneri}
  deti:array of integer;      {vsechni deti}
  constructor Vytvor(id,jmeno,prijmeni:string; muz:boolean; narozeni, umrti
               :string; matka,otec:string);
  procedure NastavDeti;
  procedure NastavPartnery;
 end;




var
  Form1: TForm1;
  rod:array of tosoba;


implementation

{$R *.DFM}

uses u27vhodnost;

constructor tosoba.Vytvor(id,jmeno,prijmeni:string; muz:boolean; narozeni, umrti
             :string; matka,otec:string);

begin
Self.id:=id;  self.jmeno:=jmeno;  self.prijmeni:=prijmeni;
self.muz:=muz; self.narozeni:=narozeni;  self.umrti:=umrti;
self.matka:=matka;  self.otec:=otec;  
SetLength(self.deti,0);  SetLength(self.partneri,0);
end;




procedure tosoba.NastavDeti;
var i:integer;
 function JeUzNalezeno(sour:integer):boolean;
  var i:integer;
  begin
   result:=false;
   for i:=0 to length(self.deti)-1 do
     if self.deti[i]=sour then result:=true;
  end;

begin
SetLength(self.deti,0);

{projizdi vsechny osoby a zjistuje, jestli je u nekoho uveden jako rodic}
{pokud ano, tak ulozi jeho ID do pole deti}
for i:=0 to length(rod)-1 do
 begin
   if ((self.muz)and(rod[i].otec=Self.id))or
      ((not self.muz)and(rod[i].matka=Self.id))
    then
     if not JeUzNalezeno(i)then
       begin
        SetLength(self.deti,length(self.deti)+1);
        self.deti[length(self.deti)-1]:=i;
       end;
 end;

end;



procedure tosoba.NastavPartnery;
var i:integer;

  function JeUzNalezeno(sour:string):boolean;
   var i:integer;
   begin
    result:=false;
    for i:=0 to length(self.partneri)-1 do
      if self.partneri[i]=sour then result:=true;
   end;

begin
SetLength(self.partneri,0);
{projizdi pole deti a do partneru pridava druheho rodice}
for i:=0 to length(self.deti)-1 do
 if self.muz then
  begin
   if not JeUzNalezeno(rod[self.deti[i]].matka)then
    begin
     SetLength(self.partneri,length(self.partneri)+1);
     self.partneri[length(partneri)-1]:=(rod[self.deti[i]].matka)
    end;
  end
 else
  begin
   if not JeUzNalezeno(rod[self.deti[i]].otec)then
    begin
     SetLength(self.partneri,length(self.partneri)+1);
     self.partneri[length(partneri)-1]:=(rod[self.deti[i]].otec)
    end;
  end;
end;




procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
SetLength(rod,0);
for i:=0 to 7 do radka.Cols[i].Add(seznam.Columns[i].caption);
end;



procedure TForm1.tlacitkootevritClick(Sender: TObject);
var soubor:TextFile;  radek,pomocne:string;
    ukoncovaci,vtagu:boolean;  i, zacatek:integer;
    jmenotagu:string;

begin
if not OpenDialog1.Execute then exit;

try  {vytvori se ze souboru jeden dlouhy string, ktery se cely projede}
{a testujou se jednotlive znaky a podle toho se ukladaji data do pole ROD}
 AssignFile(soubor,OpenDialog1.FileName);
 radek:='';
 reset(soubor);
 while not seekeof(soubor) do
  begin
   readln(soubor,pomocne);
   radek:=radek+pomocne;
  end;
 CloseFile(soubor);
except
MessageDlg('Chyba pi natn ze souboru',mtError,[mbOk],0);
SetLength(rod,0);
end;

ukoncovaci:=false; vtagu:=false; jmenotagu:='';
SetLength(rod,0);

for i:=1 to length(radek)do
 begin
  if (radek[i]='<')and(radek[i+1]='/') then
   begin
    if vtagu then
      begin
       if jmenotagu='id' then
             rod[length(rod)-1].id:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='jmeno' then
             rod[length(rod)-1].jmeno:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='prijmeni' then
             rod[length(rod)-1].prijmeni:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='pohlavi' then
             rod[length(rod)-1].muz:= (copy(radek,zacatek,i-zacatek)='M')
       else if jmenotagu='narozeni' then
             rod[length(rod)-1].narozeni:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='umrti' then
             rod[length(rod)-1].umrti:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='matka' then
             rod[length(rod)-1].matka:=copy(radek,zacatek,i-zacatek)
       else if jmenotagu='otec' then
             rod[length(rod)-1].otec:=copy(radek,zacatek,i-zacatek);

      end;
    ukoncovaci:=true; vtagu:=false;zacatek:=i+2;
   end;

  if (radek[i]='<')and(radek[i+1]<>'/') then
   begin
    ukoncovaci:=false; vtagu:=false; zacatek:=i+1;
   end;

  if (radek[i]='>') then
   begin
    if not ukoncovaci then
     begin
      jmenotagu:=copy(radek,zacatek,i-zacatek);
      if jmenotagu='rodokmen' then SetLength(rod,0)
      else if jmenotagu='osoba' then
            begin
             setlength(rod,length(rod)+1);
             rod[length(rod)-1]:=tosoba.Create;
            end
     end;
    vtagu:=not ukoncovaci; zacatek:=i+1;
   end;

 end;

Prekreslit;
end;





{prekresli obrazovku  podle aktualnich dat}
procedure TForm1.Prekreslit;
var i,ii:integer;    polozka:TListItem;    pomoc:string;
begin

for i:=0 to length(rod)-1 do
 begin  rod[i].NastavDeti; rod[i].NastavPartnery; end;


seznam.Items.Clear;
for i:=0 to 7 do radka.Cells[i,1]:='';

for i:=0 to length(rod)-1 do
 begin
  polozka:=seznam.Items.Add;
  polozka.Caption:=rod[i].id;
  polozka.SubItems.Add(rod[i].jmeno);
  polozka.SubItems.Add(rod[i].prijmeni);
  if rod[i].muz then polozka.SubItems.Add('M')else polozka.SubItems.Add('Z');
  polozka.SubItems.Add(rod[i].narozeni);
  polozka.SubItems.Add(rod[i].umrti);
  polozka.SubItems.Add(rod[i].matka);
  polozka.SubItems.Add(rod[i].otec);

  pomoc:='';
  for ii:=0 to length(rod[i].deti)-1 do
   begin
    pomoc:=pomoc+rod[rod[i].deti[ii]].id;
    if ii<>length(rod[i].deti)-1 then pomoc:=pomoc+',';
   end;
  polozka.SubItems.Add(pomoc);

  pomoc:='';
  for ii:=0 to length(rod[i].partneri)-1 do
   begin
    pomoc:=pomoc+rod[i].partneri[ii];
    if ii<>length(rod[i].partneri)-1 then pomoc:=pomoc+',';
   end;
  polozka.SubItems.Add(pomoc);
 end;
end;




{zobrazi v editovaci radce udaje, ktere byly vybrany}
procedure TForm1.seznamClick(Sender: TObject);
var i:integer;
begin
if (seznam.SelCount<=0)or(seznam.Items.Count<=0) then exit;
radka.Cells[0,1]:=seznam.Selected.Caption;

for i:=1 to 7 do
 radka.Cells[i,1]:=seznam.Selected.SubItems.Strings[i-1];

end;



{vlozi novy udaj}
procedure TForm1.tlacitkonoveClick(Sender: TObject);
begin
if not KontrolaUdaju then exit;

SetLength(rod,length(rod)+1);

rod[length(rod)-1]:=tosoba.Vytvor(radka.Cells[0,1],radka.Cells[1,1],
 radka.Cells[2,1],radka.Cells[3,1]='M',radka.Cells[4,1],radka.Cells[5,1],
 radka.Cells[6,1],radka.Cells[7,1]);

Prekreslit;
end;


{zmeni jiz existujici polozku}
procedure TForm1.tlacitkoprepsatClick(Sender: TObject);
var i,index:integer;
begin
if (seznam.SelCount<=0)or(seznam.Items.Count<=0) then exit;
if not KontrolaUdaju then exit;


for i:=0 to length(rod)-1 do
 if rod[i].id=seznam.Selected.Caption then
  begin
   index:=i;break;
  end;

with rod[index] do
 begin
  id:=radka.Cells[0,1]; jmeno:=radka.Cells[1,1];
  prijmeni:=radka.Cells[2,1]; muz:=(radka.Cells[3,1]='M');
  narozeni:=radka.Cells[4,1]; umrti:=radka.Cells[5,1];
  matka:=radka.Cells[6,1];  otec:=radka.Cells[7,1];
 end;  

Prekreslit; 
end;



function TForm1.KontrolaUdaju: boolean;
begin
result:=true;

if (radka.Cells[0,1]='')or(radka.Cells[1,1]='')or(radka.Cells[2,1]='')or
   (radka.Cells[3,1]='')or(radka.Cells[4,1]='')  then result:=false;

if not result then   MessageDlg('patn vstupn data !',mtError,[mbOk],0);
end;


{ulozeni aktualnich dat do souboru}
procedure TForm1.tlacitkoulozitClick(Sender: TObject);
var soubor:TextFile; i:integer;
begin
if not SaveDialog1.Execute then exit;

try
 AssignFile(soubor,savedialog1.FileName);
 rewrite(soubor);
 writeln(soubor,'<rodokmen>');

 for i:=0 to length(rod)-1 do
  begin
   writeln(soubor,' <osoba>');
   writeln(soubor,'  <id>'+rod[i].id+'</id>');
   writeln(soubor,'  <jmeno>'+rod[i].jmeno+'</jmeno>');
   writeln(soubor,'  <prijmeni>'+rod[i].prijmeni+'</prijmeni>');
   write(soubor,'  <pohlavi>');
   if rod[i].muz then write(soubor,'M') else write(soubor,'Z');
   writeln(soubor,'</pohlavi>');
   writeln(soubor,'  <narozeni>'+rod[i].narozeni+'</narozeni>');
   writeln(soubor,'  <umrti>'+rod[i].umrti+'</umrti>');
   writeln(soubor,'  <matka>'+rod[i].matka+'</matka>');
   writeln(soubor,'  <otec>'+rod[i].otec+'</otec>');
   writeln(soubor,' </osoba>');
  end;

 writeln(soubor,'</rodokmen>');
 CloseFile(soubor);
except
MessageDlg('Chyba pi zpisu do souboru !',mtError,[mbOK],0);exit;
end;

end;


{smazani oznacene polozky}
procedure TForm1.tlacitkosmazatClick(Sender: TObject);
var i,index:integer;  pomoc:tosoba;
begin
if (seznam.SelCount<=0)or(seznam.Items.Count<=0) then exit;

for i:=0 to length(rod)-1 do
 if rod[i].id=seznam.Selected.Caption then
  begin index:=i; break end;

pomoc:=rod[length(rod)-1];
rod[index]:=pomoc;
SetLength(rod,length(rod)-1);

Prekreslit;
end;



procedure TForm1.vhodnytlacitkoClick(Sender: TObject);
begin
form2.ShowModal;
end;

end.
